Index: NEMO/branches/2020/dev_r12953_ENHANCE-10_acc_fix_traqsr/tests/STATION_ASF/EXPREF/file_def_nemo-oce.xml
===================================================================
--- NEMO/branches/2020/dev_r12953_ENHANCE-10_acc_fix_traqsr/tests/STATION_ASF/EXPREF/file_def_nemo-oce.xml	(revision 13121)
+++ NEMO/branches/2020/dev_r12953_ENHANCE-10_acc_fix_traqsr/tests/STATION_ASF/EXPREF/file_def_nemo-oce.xml	(revision 13195)
@@ -34,4 +34,10 @@
       <field field_ref="Ce_oce"       name="Ce_oce" />
       <field field_ref="Ch_oce"       name="Ch_oce" />
+      <field field_ref="theta_zt"     name="theta_zt" />
+      <field field_ref="q_zt"         name="q_zt" />
+      <field field_ref="theta_zu"     name="theta_zu" />
+      <field field_ref="q_zu"         name="q_zu" />
+      <field field_ref="ssq"          name="ssq" />
+      <field field_ref="wspd_blk"     name="wspd_blk" />      
     </file>
 
Index: NEMO/branches/2020/dev_r12953_ENHANCE-10_acc_fix_traqsr/tests/STATION_ASF/EXPREF/launch_sasf.sh
===================================================================
--- NEMO/branches/2020/dev_r12953_ENHANCE-10_acc_fix_traqsr/tests/STATION_ASF/EXPREF/launch_sasf.sh	(revision 13121)
+++ NEMO/branches/2020/dev_r12953_ENHANCE-10_acc_fix_traqsr/tests/STATION_ASF/EXPREF/launch_sasf.sh	(revision 13195)
@@ -1,35 +1,58 @@
 #!/bin/bash
 
-# NEMO directory where to fetch compiled STATION_ASF nemo.exe + setup:
-NEMO_DIR=`pwd | sed -e "s|/tests/STATION_ASF/EXPREF||g"`
+################################################################
+#
+# Script to launch a set of STATION_ASF simulations
+#
+# L. Brodeau, 2020
+#
+################################################################
 
-echo "Using NEMO_DIR=${NEMO_DIR}"
-
-# what directory inside "tests" actually contains the compiled test-case?
+# What directory inside "tests" actually contains the compiled "nemo.exe" for STATION_ASF ?
 TC_DIR="STATION_ASF2"
 
-# => so the executable to use is:
-NEMO_EXE="${NEMO_DIR}/tests/${TC_DIR}/BLD/bin/nemo.exe"
+# DATA_IN_DIR => Directory containing sea-surface + atmospheric forcings
+#             (get it there https://drive.google.com/file/d/1MxNvjhRHmMrL54y6RX7WIaM9-LGl--ZP/):
+if [ `hostname` = "merlat"        ]; then
+    DATA_IN_DIR="/MEDIA/data/STATION_ASF/input_data_STATION_ASF_2016-2018"
+elif [ `hostname` = "luitel"        ]; then
+    DATA_IN_DIR="/data/gcm_setup/STATION_ASF/input_data_STATION_ASF_2016-2018"
+elif [ `hostname` = "ige-meom-cal1" ]; then
+    DATA_IN_DIR="/mnt/meom/workdir/brodeau/STATION_ASF/input_data_STATION_ASF_2016-2018"
+elif [ `hostname` = "salvelinus" ]; then
+    DATA_IN_DIR="/opt/data/STATION_ASF/input_data_STATION_ASF_2016-2018"
+else
+    echo "Oops! We don't know `hostname` yet! Define 'DATA_IN_DIR' in the script!"; exit 
+fi
+
+expdir=`basename ${PWD}`; # we expect "EXPREF" or "EXP00" normally...
+
+# NEMOGCM root directory where to fetch compiled STATION_ASF nemo.exe + setup:
+NEMO_WRK_DIR=`pwd | sed -e "s|/tests/STATION_ASF/${expdir}||g"`
 
 # Directory where to run the simulation:
-WORK_DIR="${HOME}/tmp/STATION_ASF"
+PROD_DIR="${HOME}/tmp/STATION_ASF"
 
 
-# FORC_DIR => Directory containing sea-surface + atmospheric forcings
-#             (get it there https://drive.google.com/file/d/1MxNvjhRHmMrL54y6RX7WIaM9-LGl--ZP/):
-if [ `hostname` = "merlat"        ]; then
-    FORC_DIR="/MEDIA/data/STATION_ASF/input_data_STATION_ASF_2016-2018"
-elif [ `hostname` = "luitel"        ]; then
-    FORC_DIR="/data/gcm_setup/STATION_ASF/input_data_STATION_ASF_2016-2018"
-elif [ `hostname` = "ige-meom-cal1" ]; then
-    FORC_DIR="/mnt/meom/workdir/brodeau/STATION_ASF/input_data_STATION_ASF_2016-2018"
-elif [ `hostname` = "salvelinus" ]; then
-    FORC_DIR="/opt/data/STATION_ASF/input_data_STATION_ASF_2016-2018"
-else
-    echo "Boo!"; exit
-fi
-#======================
-mkdir -p ${WORK_DIR}
+####### End of normal user configurable section #######
 
+#================================================================================
+
+# NEMO executable to use is:
+NEMO_EXE="${NEMO_WRK_DIR}/tests/${TC_DIR}/BLD/bin/nemo.exe"
+
+
+echo "###########################################################"
+echo "#        S T A T I O N   A i r  -  S e a   F l u x        #"
+echo "###########################################################"
+echo
+echo " We shall work in here: ${STATION_ASF_DIR}/"
+echo " NEMOGCM   work    depository is: ${NEMO_WRK_DIR}/"
+echo "   ==> NEMO EXE to use: ${NEMO_EXE}"
+echo " Input forcing data into: ${DATA_IN_DIR}/"
+echo " Production will be done into: ${PROD_DIR}/"
+echo
+
+mkdir -p ${PROD_DIR}
 
 if [ ! -f ${NEMO_EXE} ]; then echo " Mhhh, no compiled 'nemo.exe' found into `dirname ${NEMO_EXE}` !"; exit; fi
@@ -40,17 +63,16 @@
 echo
 
-
-NEMO_EXPREF="${NEMO_DIR}/tests/STATION_ASF/EXPREF"
+NEMO_EXPREF="${NEMO_WRK_DIR}/tests/STATION_ASF/EXPREF"
 if [ ! -d ${NEMO_EXPREF} ]; then echo " Mhhh, no EXPREF directory ${NEMO_EXPREF} !"; exit; fi
 
-rsync -avP ${NEMO_EXE}          ${WORK_DIR}/
+rsync -avP ${NEMO_EXE}          ${PROD_DIR}/
 
 for ff in "context_nemo.xml" "domain_def_nemo.xml" "field_def_nemo-oce.xml" "file_def_nemo-oce.xml" "grid_def_nemo.xml" "iodef.xml" "namelist_ref"; do
     if [ ! -f ${NEMO_EXPREF}/${ff} ]; then echo " Mhhh, ${ff} not found into ${NEMO_EXPREF} !"; exit; fi
-    rsync -avPL ${NEMO_EXPREF}/${ff} ${WORK_DIR}/
+    rsync -avPL ${NEMO_EXPREF}/${ff} ${PROD_DIR}/
 done
 
 # Copy forcing to work directory:
-rsync -avP ${FORC_DIR}/Station_PAPA_50N-145W*.nc ${WORK_DIR}/
+rsync -avP ${DATA_IN_DIR}/Station_PAPA_50N-145W*.nc ${PROD_DIR}/
 
 for CASE in "ECMWF" "COARE3p6" "NCAR" "ECMWF-noskin" "COARE3p6-noskin"; do
@@ -64,8 +86,8 @@
     scase=`echo "${CASE}" | tr '[:upper:]' '[:lower:]'`
 
-    rm -f ${WORK_DIR}/namelist_cfg
-    rsync -avPL ${NEMO_EXPREF}/namelist_${scase}_cfg ${WORK_DIR}/namelist_cfg
+    rm -f ${PROD_DIR}/namelist_cfg
+    rsync -avPL ${NEMO_EXPREF}/namelist_${scase}_cfg ${PROD_DIR}/namelist_cfg
 
-    cd ${WORK_DIR}/
+    cd ${PROD_DIR}/
     echo
     echo "Launching NEMO !"
Index: NEMO/branches/2020/dev_r12953_ENHANCE-10_acc_fix_traqsr/tests/STATION_ASF/MY_SRC/stpctl.F90
===================================================================
--- NEMO/branches/2020/dev_r12953_ENHANCE-10_acc_fix_traqsr/tests/STATION_ASF/MY_SRC/stpctl.F90	(revision 13121)
+++ NEMO/branches/2020/dev_r12953_ENHANCE-10_acc_fix_traqsr/tests/STATION_ASF/MY_SRC/stpctl.F90	(revision 13195)
@@ -111,7 +111,15 @@
       !                                   !==  done by all processes at every time step  ==!
       llmsk(:,:) = tmask(:,:,1) == 1._wp
-      zmax(1) = MAXVAL(     taum(:,:)   , mask = llmsk )   ! max wind stress module
-      zmax(2) = MAXVAL( ABS( qns(:,:) ) , mask = llmsk )   ! max non-solar heat flux
-      zmax(3) = MAXVAL( ABS( emp(:,:) ) , mask = llmsk )   ! max E-P
+      IF( COUNT( llmsk(:,:) ) > 0 ) THEN   ! avoid huge values sent back for land processors...
+         zmax(1) = MAXVAL(     taum(:,:)   , mask = llmsk )   ! max wind stress module
+         zmax(2) = MAXVAL( ABS( qns(:,:) ) , mask = llmsk )   ! max non-solar heat flux
+         zmax(3) = MAXVAL( ABS( emp(:,:) ) , mask = llmsk )   ! max E-P
+      ELSE
+         IF( ll_colruns ) THEN    ! default value: must not be kept when calling mpp_max -> must be as small as possible
+            zmax(1:3) = -HUGE(1._wp)
+         ELSE                     ! default value: must not give true for any of the tests bellow (-> avoid manipulating HUGE...)
+            zmax(1:3) = 0._wp
+         ENDIF
+      ENDIF
       zmax(4) = REAL( nstop, wp )                                     ! stop indicator
       !                                   !==               get global extrema             ==!
Index: NEMO/branches/2020/dev_r12953_ENHANCE-10_acc_fix_traqsr/tests/STATION_ASF/README.md
===================================================================
--- NEMO/branches/2020/dev_r12953_ENHANCE-10_acc_fix_traqsr/tests/STATION_ASF/README.md	(revision 13121)
+++ NEMO/branches/2020/dev_r12953_ENHANCE-10_acc_fix_traqsr/tests/STATION_ASF/README.md	(revision 13195)
@@ -1,4 +1,8 @@
 
 ## WARNING: TOTALLY-ALPHA-STUFF / DOCUMENT IN THE PROCESS OF BEING WRITEN!
+
+NOTE: if working with the trunk of NEMO, you are strongly advised to use the same test-case but on the `NEMO-examples` GitHub depo:
+https://github.com/NEMO-ocean/NEMO-examples/tree/master/STATION_ASF
+
 
 # *Station Air-Sea Fluxes* demonstration case