Index: NEMO/branches/2020/dev_r12377_KERNEL-06_techene_e3/tests/STATION_ASF/EXPREF/launch_sasf.sh
===================================================================
--- NEMO/branches/2020/dev_r12377_KERNEL-06_techene_e3/tests/STATION_ASF/EXPREF/launch_sasf.sh	(revision 13219)
+++ NEMO/branches/2020/dev_r12377_KERNEL-06_techene_e3/tests/STATION_ASF/EXPREF/launch_sasf.sh	(revision 13228)
@@ -15,36 +15,68 @@
 WORK_DIR="${HOME}/tmp/STATION_ASF"
 
-
-# FORC_DIR => Directory containing sea-surface + atmospheric forcings
+# DATA_IN_DIR => Directory containing sea-surface + atmospheric forcings
 #             (get it there https://drive.google.com/file/d/1MxNvjhRHmMrL54y6RX7WIaM9-LGl--ZP/):
 if [ `hostname` = "merlat"        ]; then
-    FORC_DIR="/MEDIA/data/STATION_ASF/input_data_STATION_ASF_2016-2018"
+    DATA_IN_DIR="/MEDIA/data/STATION_ASF/input_data_STATION_ASF_2016-2018"
 elif [ `hostname` = "luitel"        ]; then
-    FORC_DIR="/data/gcm_setup/STATION_ASF/input_data_STATION_ASF_2016-2018"
+    DATA_IN_DIR="/data/gcm_setup/STATION_ASF/input_data_STATION_ASF_2016-2018"
 elif [ `hostname` = "ige-meom-cal1" ]; then
-    FORC_DIR="/mnt/meom/workdir/brodeau/STATION_ASF/input_data_STATION_ASF_2016-2018"
+    DATA_IN_DIR="/mnt/meom/workdir/brodeau/STATION_ASF/input_data_STATION_ASF_2016-2018"
 elif [ `hostname` = "salvelinus" ]; then
-    FORC_DIR="/opt/data/STATION_ASF/input_data_STATION_ASF_2016-2018"
+    DATA_IN_DIR="/opt/data/STATION_ASF/input_data_STATION_ASF_2016-2018"
 else
-    echo "Boo!"; exit
+    echo "Oops! We don't know `hostname` yet! Define 'DATA_IN_DIR' in the script!"; exit 
 fi
-#======================
-mkdir -p ${WORK_DIR}
 
 
 if [ ! -f ${NEMO_EXE} ]; then echo " Mhhh, no compiled nemo.exe found into ${NEMO_DIR}/tests/STATION_ASF/BLD/bin !"; exit; fi
 
-NEMO_EXPREF="${NEMO_DIR}/tests/STATION_ASF/EXPREF"
+# NEMOGCM root directory where to fetch compiled STATION_ASF nemo.exe + setup:
+NEMO_WRK_DIR=`pwd | sed -e "s|/tests/STATION_ASF/${expdir}||g"`
+
+# Directory where to run the simulation:
+PROD_DIR="${HOME}/tmp/STATION_ASF"
+
+
+####### End of normal user configurable section #######
+
+#================================================================================
+
+# NEMO executable to use is:
+NEMO_EXE="${NEMO_WRK_DIR}/tests/${TC_DIR}/BLD/bin/nemo.exe"
+
+
+echo "###########################################################"
+echo "#        S T A T I O N   A i r  -  S e a   F l u x        #"
+echo "###########################################################"
+echo
+echo " We shall work in here: ${STATION_ASF_DIR}/"
+echo " NEMOGCM   work    depository is: ${NEMO_WRK_DIR}/"
+echo "   ==> NEMO EXE to use: ${NEMO_EXE}"
+echo " Input forcing data into: ${DATA_IN_DIR}/"
+echo " Production will be done into: ${PROD_DIR}/"
+echo
+
+mkdir -p ${PROD_DIR}
+
+if [ ! -f ${NEMO_EXE} ]; then echo " Mhhh, no compiled 'nemo.exe' found into `dirname ${NEMO_EXE}` !"; exit; fi
+
+echo
+echo " *** Using the following NEMO executable:"
+echo "  ${NEMO_EXE} "
+echo
+
+NEMO_EXPREF="${NEMO_WRK_DIR}/tests/STATION_ASF/EXPREF"
 if [ ! -d ${NEMO_EXPREF} ]; then echo " Mhhh, no EXPREF directory ${NEMO_EXPREF} !"; exit; fi
 
-rsync -avP ${NEMO_EXE}          ${WORK_DIR}/
+rsync -avP ${NEMO_EXE}          ${PROD_DIR}/
 
 for ff in "context_nemo.xml" "domain_def_nemo.xml" "field_def_nemo-oce.xml" "file_def_nemo-oce.xml" "grid_def_nemo.xml" "iodef.xml" "namelist_ref"; do
     if [ ! -f ${NEMO_EXPREF}/${ff} ]; then echo " Mhhh, ${ff} not found into ${NEMO_EXPREF} !"; exit; fi
-    rsync -avPL ${NEMO_EXPREF}/${ff} ${WORK_DIR}/
+    rsync -avPL ${NEMO_EXPREF}/${ff} ${PROD_DIR}/
 done
 
 # Copy forcing to work directory:
-rsync -avP ${FORC_DIR}/Station_PAPA_50N-145W*.nc ${WORK_DIR}/
+rsync -avP ${DATA_IN_DIR}/Station_PAPA_50N-145W*.nc ${PROD_DIR}/
 
 for CASE in "ECMWF" "COARE3p6" "NCAR" "ECMWF-noskin" "COARE3p6-noskin"; do
@@ -58,8 +90,8 @@
     scase=`echo "${CASE}" | tr '[:upper:]' '[:lower:]'`
 
-    rm -f ${WORK_DIR}/namelist_cfg
-    rsync -avPL ${NEMO_EXPREF}/namelist_${scase}_cfg ${WORK_DIR}/namelist_cfg
+    rm -f ${PROD_DIR}/namelist_cfg
+    rsync -avPL ${NEMO_EXPREF}/namelist_${scase}_cfg ${PROD_DIR}/namelist_cfg
 
-    cd ${WORK_DIR}/
+    cd ${PROD_DIR}/
     echo
     echo "Launching NEMO !"
Index: NEMO/branches/2020/dev_r12377_KERNEL-06_techene_e3/tests/STATION_ASF/MY_SRC/step_c1d.F90
===================================================================
--- NEMO/branches/2020/dev_r12377_KERNEL-06_techene_e3/tests/STATION_ASF/MY_SRC/step_c1d.F90	(revision 13219)
+++ NEMO/branches/2020/dev_r12377_KERNEL-06_techene_e3/tests/STATION_ASF/MY_SRC/step_c1d.F90	(revision 13228)
@@ -78,10 +78,11 @@
       ! Control and restarts
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-      CALL stp_ctl( kstp, Nbb, Nnn, indic )
+      CALL stp_ctl( kstp, Nnn )
+
       IF( kstp == nit000 )   CALL iom_close( numror )          ! close input  ocean restart file
       IF( lrst_oce       )   CALL rst_write( kstp, Nbb, Nnn )  ! write output ocean restart file
       !
 #if defined key_iomput
-      IF( kstp == nitend .OR. indic < 0 )   CALL xios_context_finalize()   ! needed for XIOS
+      IF( kstp == nitend .OR. nstop > 0 )   CALL xios_context_finalize()   ! needed for XIOS
       !
 #endif